# -*- coding: utf-8 -*-
"""
Created on Mon Apr  9 16:43:36 2018

@author: eivin
"""

import sys
import numpy as np
import os, errno
#import os
import time
import subprocess as sp
import matplotlib.pyplot as plt

def getDataFiles():
    dataFile=open(dataFileName)    
    modelsData=[]
    for line in dataFile:
        dataList=[]
        data=line.split()
        for d in data:
            dataList.append(d.strip(' \t\n\r'))
        modelsData.append(dataList)         
    dataFile.close()
    
    if len(modelsData) < numLines:
        print('Too many jobs requested!\n')
        sys.exit(0)
    elif (lineStart-1) < 0:
        print('Invalid start number!\n')
        sys.exit(0)
    elif (len(modelsData)-(lineStart-1)) < numLines:
        print('Not enough datalines left to give', numLines,'results\n')   
        sys.exit(0)
    else:
        print('Number of lines accepted!\n')
    return(modelsData) 
    
def makeTheDir(lineStart, numLines):
    start = str(lineStart)
    end = str(lineStart+numLines-1)
    dirName =caseU+'_'+start+'_to_'+end
    try:
        os.makedirs(dirName)
    except OSError as e:
        if e.errno != errno.EEXIST:
            raise
    return(dirName)
    
def makeModelBatches(lineStart, numLines):
    start = str(lineStart)
    num = str(numLines)
    
    batch = open('batch.bat','w')
    lines =  ['abaqus cae script=',mainDir,'\\',caseU,'_abaqus.py -- ', start+' ', num+' ', dataFileName+' ', str(numSteps)]
    batch.writelines(lines)
    batch.close()

def runModelBatch():        
    sp.call('batch.bat')

def makeJobBatch():
    jobs = open('jobSubmit.bat','w')
    jobs.write('')
    jobs.close()
    jobs = open('jobSubmit.bat','a')
    jobs.write('(\n')
    for i in range(lineStart, lineStart+numLines):
        if i < 10:
            jobName = case+'-m00'+str(i)
            jobNameL = case+'-m00'+str(i)+'-L'
        elif i < 100:
            jobName = case+'-m0'+str(i)
            jobNameL = case+'-m0'+str(i)+'-L'
        else:
            jobName = case+'-m'+str(i)
            jobName = case+'-m'+str(i)+'-L'
                
        lines = ['abaqus job=', jobName, ' ', 'input=', jobName, ' ask_delete=OFF','\n']
        linesL = ['abaqus job=', jobNameL, ' ', 'input=', jobNameL, ' ask_delete=OFF', '\n']
        jobs.writelines(lines)
        jobs.writelines(linesL)
    jobs.write(')')    
    jobs.close()
    
def submitJobs():
    print('Running Jobs...\n')
    sp.call('jobSubmit.bat')

def checker(var):
    if var == 1:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir):
                if fname.endswith('.inp'):
                    check = 1
                    break
            else:
                time.sleep(0.1)
                
    elif var == 2:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir): # '.' - means current directory
                if fname.endswith('.lck'):
                    check = 1
                    break
            else:
                time.sleep(1)
                
    elif var == 3:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir): # '.' - means current directory
                if fname.endswith('.lck'):
                    time.sleep(1)
                    break
            else:
                check = 1
    
def getResults():
    s = str(lineStart)
    n = str(numLines)
    command ='abaqus cae script=',mainDir,'\\',caseU,'_results.py -- {0} {1} {2}'.format(numSteps,s,n)
    
    results = open('results.bat','w')
    results.writelines(command)
    results.close()
    sp.call('results.bat')
    
def plotResults(r,mDat):
   
    x = []
    y = []
    
    for i in range(lineStart, lineStart+r):
         # Non-linear
        if i<10:
            ip = str(i)
            x, y = np.loadtxt(case+'-m00'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=case+'-m00'+ip,ls='--',c='b')
        elif i<100:
            ip = str(i)
            x, y = np.loadtxt(case+'-m0'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=case+'-m0'+ip,ls='--',c='b')
        else: 
            ip = str(i)
            x, y = np.loadtxt(case+'-m'+ip+'.txt', delimiter='\t', unpack=True)
            plt.plot(x,y,label=case+'-m'+ip,ls='--',c='b')
            
    
    plt.xlabel('Curvature about Y, Ky')
    plt.ylabel('Moment about Y, My')
    plt.title('Non-linear Contact Analysis for YdX')
    plt.legend()
    plt.show()
    plt.savefig(case+'-'+str(lineStart)+'-'+str(lineStop)+'.png')
    plt.savefig(case+'-'+str(lineStart)+'-'+str(lineStop)+'.pdf',format='pdf')

# =============================================================================
# Global parameters
# =============================================================================
numSteps = 10
case = 'c-YdX'
caseU = 'c_YdX'
mainDir = 'C:\\Users\\Eivind\\Documents\\Master\\FinalAnalysis\\Contact\\contact_YdX'
printNumber = 1
# =============================================================================
# Main program
# =============================================================================

#lineStart = int(input('What is the start line in the models data? '))
#numLines = int(input('How many models shall be created an run? '))
lineStart = 1
numLines = 1
lineStop = lineStart + numLines - 1


os.chdir(mainDir)
dirName = makeTheDir(lineStart, numLines)
os.chdir(os.getcwd()+'\\'+dirName)
jobDir = os.getcwd()
dataFileName = mainDir +'\\modelsData_YdX.txt'

modelsData = getDataFiles()

#makeModelBatches(lineStart, numLines)
#runModelBatch()
#
#checker(1)
    
print('The models are done!\n')

#makeJobBatch()
#submitJobs()

#checker(2)
#checker(3)
#         
print('The simulations are done!\n')

getResults()
plotResults(numLines, modelsData)
