# -*- coding: utf-8 -*-
"""
Created on Wed Apr 25 13:53:10 2018

@author: eivin
"""

import sys
import numpy as np
import os, errno
#import os
import time
import subprocess as sp
import matplotlib.pyplot as plt
import pandas as pd

def getDataFiles(elemName):
    dataFile=open(dataFileName)    
    modelsData=[]
    for line in dataFile:
        dataList=[]
        data=line.split()
        for d in data:
            dataList.append(d.strip(' \t\n\r'))
        modelsData.append(dataList)         
    dataFile.close()
    
    if len(modelsData) < numLines:
        print('Too many jobs requested!\n')
        sys.exit(0)
    elif (lineStart-1) < 0:
        print('Invalid start number!\n')
        sys.exit(0)
    elif (len(modelsData)-(lineStart-1)) < numLines:
        print('Not enough datalines left to give', numLines,'results\n')   
        sys.exit(0)
    else:
        print('Number of lines accepted!\n')
    return(modelsData) 
    
def makeTheDir(lineStart, numLines, elemName):
    start = str(lineStart)
    end = str(lineStart+numLines-1)
    dirName = subDirName+'_'+elemName+'_'+start+'_to_'+end
    try:
        os.makedirs(dirName)
    except OSError as e:
        if e.errno != errno.EEXIST:
            raise
    return(dirName)
    
def makeModelBatches(lineStart, numLines, elemName):
    start = str(lineStart)
    num = str(numLines)
    
    batch = open(elemName+'_batch.bat','w')
    lines =  ['abaqus cae script=',mainDir,'\\',case,'_abaqus','.py -- ', start+' ', num+' ', dataFileName]
    batch.writelines(lines)
    batch.close()

def runModelBatch(elemName):        
    sp.call(elemName+'_batch.bat')

def makeJobBatch(elemName):
    for i in range(lineStart, lineStart+numLines):    
        if i < 10:
            modName =case+'-m00'+str(i)+'-L'
        elif i < 100:
            modName =case+'-m0'+str(i)+'-L'
        else:
            modName =case+'-m'+str(i)+'-L'
        jobs = open(elemName+'_'+modName+'_jobSubmit.bat','w')
        jobs.write('')
        jobs.close()
        jobs = open(elemName+'_'+modName+ '_jobSubmit.bat','a')
        jobs.write('(\n')  
        for counter in range(6):            
            if i < 10:
                modName =case+'-m00'+str(i)+'-L'
                jobNameL = case+'-m00'+str(i)+'-L-'+str(counter)
            elif i < 100:
                modName =case+'-m0'+str(i)+'-L'
                jobNameL = case+'-m0'+str(i)+'-L-'+str(counter)
            else:
                modName =case+'-m'+str(i)+'-L'
                jobNameL = case+'-m'+str(i)+'-L-'+str(counter)
              
            linesL = ['abaqus job=', jobNameL, ' ', 'input=', jobNameL, ' ask_delete=OFF', '\n']
            jobs.writelines(linesL)
        jobs.write(')')    
        jobs.close()
    
def submitJobs(elemName):
    print('Running Jobs...\n')
    for i in range(lineStart, lineStart+numLines):             
        for counter in range(6):            
            if i < 10:
                modName =case+'-m00'+str(i)+'-L'
#                jobNameL = 'Job-m00'+str(i)+'L-'+str(counter)
            elif i < 100:
                modName =case+'-m0'+str(i)+'-L'
#                jobNameL = 'Job-m0'+str(i)+'L'+str(counter)
            else:
                modName =case+'-m'+str(i)+'-L'
#                jobNameL = 'Job-m'+str(i)+'L'+str(counter)
        sp.call(elemName+'_'+modName+'_jobSubmit.bat')           
        checker(2)    
        checker(3)

def setTime(elemName):
    outfile = 'times-'+elemName+'.txt'
    if os.path.isfile(jobDir+'\\'+outfile):
        os.remove(outfile)
    for i in range(lineStart, lineStart+numLines):
        for counter in range(6):
            if i < 10:
                jobNameL = case+'-m00'+str(i)+'-L-'+str(counter)
            elif i < 100:
                jobNameL = case+'-m0'+str(i)+'-L-'+str(counter)
            else:
                jobNameL = case+'-m'+str(i)+'-L-'+str(counter)
        print(jobNameL)
        substr, infile = 'JOB TIME SUMMARY', jobNameL+'.msg'
        check = 0        
        with open(infile) as a, open(outfile, 'a') as b:
            for line in a:
                if substr in line:
                    check = 1                    
                if check == 1:
                    if 'TOTAL CPU TIME' in line:
                        b.write(line[31:38]+'\n')
 
def checker(int):
    if int == 1:
        check = 0
        cnt = 0
        while check == 0:    
            for fname in os.listdir(jobDir): # '.' - means current directory
                if fname.endswith('.inp'):
                    cnt = cnt +1
                    if cnt == 5:
                        check = 1
                        break
            else:
                time.sleep(0.1)
                
    elif int == 2:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir): # '.' - means current directory
                if fname.endswith('.lck'):
                    check = 1
                    break
            else:
                time.sleep(1)
                
    elif int == 3:
        check = 0
        while check == 0:    
            for fname in os.listdir(jobDir): # '.' - means current directory
                if fname.endswith('.lck'):
                    time.sleep(1)
                    break
            else:
                check = 1
    
def getResults(elemName):
    s = str(lineStart)
    n = str(numLines)
    command ='abaqus cae script=',mainDir,'\\',case,'_results','.py -- {0} {1}'.format(s,n)
    
    results = open(elemName+'_results.bat','w')
    results.writelines(command)
    results.close()
    sp.call(elemName+'_results.bat')
    
def normalizeArray(tab): # Normalize the values for the last value in the array
#    tab = [Axx,Ayy,Axy,Ass,Dxx,Dyy,Dxy,Dss]
    norm = []
    for i in range(len(tab)):
#        print(tab[i][0])
#        maxVal = max(tab[i][0])
        normalized = []
        for j in range(len(tab[i][0])):
#            print(tab[i][j])
            normalized.append(tab[i][0][j]/tab[i][0][-1])
        norm.append(normalized)
#        print(normalized)    
    return(norm[0],norm[1],norm[2],norm[3],norm[4],norm[5],norm[6],norm[7])
    
def plotResults(start,stop,folders):
    
    elemNum = []
    Axx,Ayy,Axy,Ass,Dxx,Dyy,Dxy,Dss = [[],[],[],[],[],[],[],[]]
    values = [Axx,Ayy,Axy,Ass,Dxx,Dyy,Dxy,Dss]
    
    for i in range(num):
        elemName = elements[i]
            
        stiffMatrix = pd.read_csv(folders[i]+'\\meshConvResults-'+str(start[i])+'-'+str(start[i]+stop[i]-1)+'.txt', sep="\t", header=None)
        print(stiffMatrix)
        elemNum.append(np.loadtxt(folders[i]+'\\elementNumbers-'+str(start[i])+'-'+str(start[i]+stop[i]-1)+'.txt', delimiter=None, usecols=None, unpack=True))
#        print(elemNum)
#        print(elemNum[0])
        
        names = np.array(stiffMatrix.iloc[0,:])
        print(names)
        
        
        for j in range(len(values)):  
#            stiffValues[j].append(np.loadtxt(folders[i]+'\\meshConvResults-'+str(start[i])+'-'+str(start[i]+stop[i]-1)+'.txt', delimiter=None, skiprows=1, usecols=(j,), unpack=True))
            v = np.array(stiffMatrix.iloc[1:(stop[i]+1),j]).astype(np.float)
            print(v)
            values[j].append(v)
#        print(values[0][0])
        print(values)
        axx,ayy,axy,ass,dxx,dyy,dxy,dss = normalizeArray(values)
        normValues = [axx,ayy,axy,ass,dxx,dyy,dxy,dss]
#        print(normValues[0][0])
        for j in range(len(values)):
            plt.plot(elemNum,normValues[j],label=names[j], marker='',linewidth=3)
#    x2 = []
#    y2 = []
#    x2, y2 = np.loadtxt('meshConvResults.txt', delimiter=None, usecols=(2,3), unpack=True)
#    plt.plot(x2,y2,label='Mesh type: '+e)
    
    plt.xlabel('Element size, '+elemName)
    plt.ylabel('Stiffness')
    plt.title('Mesh Convergence')
    plt.legend()
#    plt.Axes.invert_xaxis()
#    plt.xlim(max(elemNum[i]),min(elemNum[i]))
    plt.show()
#    os.chdir(mainDir)
    
    plt.savefig(os.getcwd()+'\\'+case+'-'+e+'-'+str(elemNum[(stop[i]-1)])+'.png',bbox_inches='tight')
    plt.savefig(os.getcwd()+'\\'+case+'-'+e+'-'+str(elemNum[(stop[i]-1)])+'.pdf',bbox_inches='tight',format='pdf')

#def errorCrit(x,y,xL,yL):
    
# =============================================================================
# Global parameters
# =============================================================================
error = 0.1
case = 'ct'
mainDir = 'C:\\Users\\eivin\\Documents\\Abaqus\\Master\\FinalAnalysis\\MeshConvergence'
subDirName = 'RVE'
elements = ['C3D20R']
#elements = ['C3D8R']

# =============================================================================
# Main program
# =============================================================================
num = 1   #This is the number of element types the script will run

lStart = []
nLines = []
resultFolders = []



for j in range(num):
    p = str(j+1)
    lStart.append(int(input('What is the start line for the '+p+'. element type? ')))
    nLines.append(int(input('How many mesh sizes? ')))

for i in range(num):
    e = elements[i]
    
    lineStart = lStart[i]
    numLines = nLines[i]
    lineStop = lineStart + numLines - 1
    
    os.chdir(mainDir)
    dirName = makeTheDir(lineStart, numLines, e)
    os.chdir(mainDir+'\\'+dirName)
    jobDir = os.getcwd()
    dataFileName = mainDir +'\\modelsData.txt'
    
    modelsData = getDataFiles(e)
    
#    makeModelBatches(lineStart, numLines, e)
#    runModelBatch(e)
#    
#    checker(1)
                 
    print('The '+e+'-models are done!\n')
        
#    makeJobBatch(e)
#    submitJobs(e)
#             
#    setTime(e)
           
    print('The '+e+'-simulations are done!\n')
    
#    getResults(e)
    
    
    resultFolders.append(jobDir)
    plotResults(lStart,nLines, resultFolders)
